Status: Closed Priority: Must have
Author: Markus Klein Category:
Created: 2013-07-05 Assigned To: Francois Suter
Updated: 2014-08-01 Due date:
Subject: label_func addition for rendering IRRE headers
Description

The new TCA option 'label_userFunc_options' allows to pass additional information to the label_userFunc.

Example:

'ctrl' => array(
    'title' => 'LLL:EXT:lang/locallang_tca.xlf:theTable',
    'label' => 'uid',
    'label_userFunc' => 'UserFunc.php:UserFunc->getInlineLabel',
    'label_userFunc_options' => array(
        'special' => array(
            'this',
            'that'
        )
    )
)

The getInlineLabel() can set the title as follows:

public function getInlineLabel(array &$params) {
    $fields = isset($params['options']['special']) && is_array($params['options']['special'])
        ? $params['options']['special']
        : array();
    $title = array();
    foreach ($fields as $f) {
        $title[] = $params['row'][$f];
    }
    $params['title'] = '<dl>' . implode('', $title) . '</dl>';

Related issues:
related to TYPO3 CMS Usability Team - Suggestion # 36052: Visual improvements... Resolved
related to Core - Bug # 51411: Label user function for sys_file_reference use... Resolved 2013-08-27
related to Core - Feature # 49721: Add label_userFunc_options to BackendUtility Resolved 2013-07-06

Associated revisions
Revision 0386ee6b - 2014-02-19 20:13 - Francois Suter

[FEATURE] Document formattedLabel_userFunc

Two new properties were added to the "ctrl" section of the TCA,
formattedLabel_userFunc and formattedLabel_userFunc_options.

Resolves: #49716
Releases: 6.2

Change-Id: Iab01736200c082d1e0b2ca7e61a37f9143fa8a8e
Reviewed-on: https://review.typo3.org/27732
Reviewed-by: Francois Suter
Tested-by: Francois Suter

History
#1 - 2013-07-05 21:17 - Markus Klein

Change: https://review.typo3.org/21916

#2 - 2013-09-01 13:47 - Philipp Gampe

The corresponding change needed a follow up, because the label must not contain markup.

Thus for IRRE headers, there is a new configuration option inlineLabel_userFunc with the same signature as the know label_userFunc. This new
config option is prefered over the normal label user function.
The additional behavior with the label_userFunc_options is preserved, although it is not used for FAL IRRE fields.

#3 - 2013-09-17 17:34 - Ernesto Baschny

Please note that the follow-up is not finished / reviewed (#51411) yet, so this is not in the core. But this has to be fixed because the current behaviour
breaks some backend elements (Workspaces, Sys-log..)

#4 - 2013-09-24 09:02 - Markus Klein

The follow-up is merged now. The new label option is called "formattedLabel_userFunc". The user can provide a function that returns a HTML
formatted label for a row. As of 6.2 this only used for displaying IRRE inline element headers.

#5 - 2014-02-19 20:12 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Documentation/TYPO3/Reference/Tca has been pushed to the review server.
It is available at https://review.typo3.org/27732

#6 - 2014-02-19 20:13 - Francois Suter
- Assigned To set to Francois Suter

#7 - 2014-02-19 20:35 - Francois Suter
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100
Applied in changeset commit:0386ee6b4b26305dae4276f4f3db1cdb1d211634.

#8 - 2014-08-01 14:22 - Francois Suter
- Status changed from Resolved to Closed
